//+------------------------------------------------------------------+
//|                                                                  |
//|                 Copyright  1999-2008, MetaQuotes Software Corp. |
//|                                         http://www.metaquotes.ru |
//+------------------------------------------------------------------+

//---- indicator settings

#property  indicator_chart_window
#property  indicator_buffers 0
//----

//---- indicator parameters

extern string          help              = "bars forward positions Level Line";
extern int             bars_forward      = 14;      //Time[0] + numberOfSecondsIntoTheFuture is Time[0]+q*Period()*60; // q bars into the future
extern double          LevelLineLength   = 0.2;     // sets length of Level Line
extern double          LabelAdjHorizontal= 0.1;     // positions label under Level Line
extern double          LabelAdjVertical  = -0.1;    // allows you to move label up and down
extern int             font_size         = 7;       // sets font size
extern string          note1             = "----timeframe----";
extern string          help1             = "set to true to add timeframe to chart";
extern bool            D1_OPEN           = true;   // set true to display MA's
extern bool            D1_HIGH           = true;   // set true to display
extern bool            D1_LOW            = true;   // set true to display
extern bool            D1_CLOSE          = true;   // set true to display NOTE CLOSE VALUES ARE PREVIOUS BAR
extern bool            M30_OPEN          = true;   // set true to display 
extern bool            M30_HIGH          = true;   // set true to display 
extern bool            M30_LOW           = true;   // set true to display
extern bool            M30_CLOSE         = true;   // set true to display NOTE CLOSE VALUES ARE PREVIOUS BAR
double                 LastOpen1,LastOpen2,LastOpen3,LastHigh1,LastHigh2,LastHigh3,LastLow1,LastLow2,LastLow3; // used to remember last high and low, no need to redraw if they haven't changed
datetime               Bar1Time;          //  used to check if the curen tick is for a new bar

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
   {
   IndicatorShortName("OTF-S&R Levels");
   
   
   //---- initialization done
   return(0);
   }    
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
   {
    ObjectDelete("D1_OPEN");
    ObjectDelete("D1_OPEN_label");
    ObjectDelete("D1_HIGH");
    ObjectDelete("D1_HIGH_label");
    ObjectDelete("D1_LOW");
    ObjectDelete("D1_LOW_label");
    ObjectDelete("D1_CLOSE");
    ObjectDelete("D1_CLOSE_label");
    ObjectDelete("M30_OPEN");
    ObjectDelete("M30_OPEN_label");
    ObjectDelete("M30_HIGH");
    ObjectDelete("M30_HIGH_label");
    ObjectDelete("M30_LOW");
    ObjectDelete("M30_LOW_label");
    ObjectDelete("M30_CLOSE");
    ObjectDelete("M30_CLOSE_label"); 
   return(0);
   }
//+------------------------------------------------------------------+
//| Other timeframe line levels                                           |
//+------------------------------------------------------------------+
int start()
       {
//-
//-------------------------------------------------------------------+
       {   // Start of D1 Loop
//-------------------------------------------------------------------+
//--   D1 calculations
//-------------------------------------------------------------------+
//     Comment("") Only update the objects if they need updating
       if( (iHigh(NULL,PERIOD_D1,0) <= LastHigh1 && iLow(NULL,PERIOD_D1,0) >= LastLow1 ) && iOpen(NULL,PERIOD_D1,0) == LastOpen1 &&
            iTime(NULL, PERIOD_D1, 1) == Bar1Time) return(0);
   
           LastOpen1 = iOpen(NULL,PERIOD_D1,0);
           LastHigh1 = iHigh(NULL,PERIOD_D1,0);
           LastLow1  = iLow (NULL,PERIOD_D1,0);
           Bar1Time  = iTime(NULL,PERIOD_D1,1);
   
//-----D1 LEVEL LINES--Comment("Redraw");
//--
       if (D1_OPEN) // draw if true
       {
       if (ObjectFind   ("D1_OPEN") == -1) 
           ObjectCreate ("D1_OPEN", OBJ_TREND, 0, 0, 0, 0, 0);
         
           ObjectSet    ("D1_OPEN", OBJPROP_TIME1,       Time[0] +  (LevelLineLength+1)  * bars_forward * 60 * Period() );
           ObjectSet    ("D1_OPEN", OBJPROP_TIME2,       Time[0] + (2*LevelLineLength+1) * bars_forward * 60 * Period() );
      
           ObjectSet    ("D1_OPEN", OBJPROP_PRICE1,      iOpen(NULL,PERIOD_D1,0) );
           ObjectSet    ("D1_OPEN", OBJPROP_PRICE2,      iOpen(NULL,PERIOD_D1,0) );
      
           ObjectSet    ("D1_OPEN", OBJPROP_RAY,         false);
           ObjectSet    ("D1_OPEN", OBJPROP_COLOR,       Lime);
           ObjectSet    ("D1_OPEN", OBJPROP_WIDTH,       3);
       }
    
       if (D1_HIGH) // draw if true
       {
       if (ObjectFind   ("D1_HIGH") == -1) 
           ObjectCreate ("D1_HIGH", OBJ_TREND, 0, 0, 0, 0, 0);
         
           ObjectSet    ("D1_HIGH", OBJPROP_TIME1,       Time[0] +  (LevelLineLength+1)* bars_forward * 60 * Period() );
           ObjectSet    ("D1_HIGH", OBJPROP_TIME2,       Time[0] + (2*LevelLineLength+1)* bars_forward * 60 * Period() );
      
           ObjectSet    ("D1_HIGH", OBJPROP_PRICE1,      iHigh(NULL, PERIOD_D1, 0) );
           ObjectSet    ("D1_HIGH", OBJPROP_PRICE2,      iHigh(NULL, PERIOD_D1, 0) );
      
           ObjectSet    ("D1_HIGH", OBJPROP_RAY,         false);
           ObjectSet    ("D1_HIGH", OBJPROP_COLOR,       Lime);
           ObjectSet    ("D1_HIGH", OBJPROP_WIDTH,       3);
       }
    
       if (D1_LOW) // draw if true
       {
       if (ObjectFind   ("D1_LOW") == -1) 
           ObjectCreate ("D1_LOW",  OBJ_TREND, 0, 0, 0, 0, 0);
         
           ObjectSet    ("D1_LOW",  OBJPROP_TIME1,       Time[0] + (LevelLineLength+1)   * bars_forward * 60 * Period() );
           ObjectSet    ("D1_LOW",  OBJPROP_TIME2,       Time[0] + (2*LevelLineLength+1) * bars_forward * 60 * Period() );
      
           ObjectSet    ("D1_LOW",  OBJPROP_PRICE1,      iLow(NULL, PERIOD_D1, 0) );
           ObjectSet    ("D1_LOW",  OBJPROP_PRICE2,      iLow(NULL, PERIOD_D1, 0) );
      
           ObjectSet    ("D1_LOW",  OBJPROP_RAY,         false);
           ObjectSet    ("D1_LOW",  OBJPROP_COLOR,       Lime);
           ObjectSet    ("D1_LOW",  OBJPROP_WIDTH,       3);
       }   
      
       if (D1_CLOSE) // draw if true
       {
       if (ObjectFind   ("D1_CLOSE") == -1) 
           ObjectCreate ("D1_CLOSE",  OBJ_TREND, 0, 0, 0, 0, 0);
         
           ObjectSet    ("D1_CLOSE",  OBJPROP_TIME1,       Time[0] + (LevelLineLength+1) * bars_forward * 60 * Period() );
           ObjectSet    ("D1_CLOSE",  OBJPROP_TIME2,       Time[0] + (2*LevelLineLength+1) * bars_forward * 60 * Period() );
      
           ObjectSet    ("D1_CLOSE",  OBJPROP_PRICE1,      iClose(NULL, PERIOD_D1, 1) );
           ObjectSet    ("D1_CLOSE",  OBJPROP_PRICE2,      iClose(NULL, PERIOD_D1, 1) );
      
           ObjectSet    ("D1_CLOSE",  OBJPROP_RAY,         false);
           ObjectSet    ("D1_CLOSE",  OBJPROP_COLOR,       Lime);
           ObjectSet    ("D1_CLOSE",  OBJPROP_WIDTH,       3);
       }   
      
      
//-----D1 LINE LABELS
//--       
       if (D1_OPEN) // draw if true
       {
       if (ObjectFind   ("D1_OPEN_label") == -1) 
           ObjectCreate ("D1_OPEN_label", OBJ_TEXT, 0, 0, 0);
      
           ObjectSet    ("D1_OPEN_label", OBJPROP_TIME1, Time[0] + (LabelAdjHorizontal+LevelLineLength+1) *bars_forward * 60 * Period() );
           ObjectSet    ("D1_OPEN_label", OBJPROP_PRICE1,(iOpen(NULL, PERIOD_D1, 0) + LabelAdjVertical));

           ObjectSet    ("D1_OPEN_label", OBJPROP_COLOR, Lime);
           ObjectSetText("D1_OPEN_label", " D1_O", font_size, "Arial", Lime); 
       }
      
       if (D1_HIGH) // draw if true
       {
       if (ObjectFind   ("D1_HIGH_label") == -1) 
           ObjectCreate ("D1_HIGH_label", OBJ_TEXT, 0, 0, 0);
      
           ObjectSet    ("D1_HIGH_label", OBJPROP_TIME1, Time[0] + (LabelAdjHorizontal+1+LevelLineLength) *bars_forward * 60 * Period() );
           ObjectSet    ("D1_HIGH_label", OBJPROP_PRICE1,(iHigh(NULL, PERIOD_D1, 0)+LabelAdjVertical) );

           ObjectSet    ("D1_HIGH_label", OBJPROP_COLOR, Lime);
           ObjectSetText("D1_HIGH_label", " D1_H", font_size, "Arial", Lime); 
       }
    
       if (D1_LOW) // draw if true
       {
       if (ObjectFind   ("D1_LOW_label") == -1) 
           ObjectCreate ("D1_LOW_label", OBJ_TEXT, 0, 0, 0);
      
           ObjectSet    ("D1_LOW_label", OBJPROP_TIME1, Time[0] + (LabelAdjHorizontal+1+LevelLineLength) *bars_forward * 60 * Period() );
           ObjectSet    ("D1_LOW_label", OBJPROP_PRICE1,(iLow(NULL, PERIOD_D1, 0) + LabelAdjVertical));

           ObjectSet    ("D1_LOW_label", OBJPROP_COLOR, Lime);
           ObjectSetText("D1_LOW_label", " D1_L", font_size, "Arial", Lime); 
       }
       
       if (D1_CLOSE) // draw if true
       {
       if (ObjectFind   ("D1_CLOSE_label") == -1) 
           ObjectCreate ("D1_CLOSE_label", OBJ_TEXT, 0, 0, 0);
      
           ObjectSet    ("D1_CLOSE_label", OBJPROP_TIME1, Time[0] + (LabelAdjHorizontal+1+LevelLineLength) *bars_forward * 60 * Period() );
           ObjectSet    ("D1_CLOSE_label", OBJPROP_PRICE1,(iClose(NULL, PERIOD_D1, 1) + LabelAdjVertical));

           ObjectSet    ("D1_CLOSE_label", OBJPROP_COLOR, Lime);
           ObjectSetText("D1_CLOSE_label", " D1_C(1)", font_size, "Arial", Lime); 
       }
//-------------------------------------------------------------------+
       }   //-End of D1 Loop
//-------------------------------------------------------------------+
//-
//-------------------------------------------------------------------+
       {   // Start of M30 Loop
//-------------------------------------------------------------------+
//--   M30 calculations
//-------------------------------------------------------------------+
       if( (iHigh(NULL,PERIOD_M30,0) <= LastHigh1 && iLow(NULL,PERIOD_M30,0) >= LastLow1 ) && iOpen(NULL,PERIOD_M30,0) == LastOpen1 &&
            iTime(NULL, PERIOD_M30, 1) == Bar1Time) return(0);
   
           LastOpen1 = iOpen(NULL,PERIOD_M30,0);
           LastHigh1 = iHigh(NULL,PERIOD_M30,0);
           LastLow1  = iLow (NULL,PERIOD_M30,0);
           Bar1Time  = iTime(NULL,PERIOD_M30,1); 

//-----M30 LEVEL LINES--Comment("Redraw");
//----
       if (M30_OPEN) // draw if true
       {
       if (ObjectFind   ("M30_OPEN") == -1) 
           ObjectCreate ("M30_OPEN", OBJ_TREND, 0, 0, 0, 0, 0);
         
           ObjectSet    ("M30_OPEN", OBJPROP_TIME1,       Time[0] +                   bars_forward * 60 * Period() );
           ObjectSet    ("M30_OPEN", OBJPROP_TIME2,       Time[0] + (LevelLineLength+1) * bars_forward * 60 * Period() );
      
           ObjectSet    ("M30_OPEN", OBJPROP_PRICE1,      iOpen(NULL,PERIOD_M30,0) );
           ObjectSet    ("M30_OPEN", OBJPROP_PRICE2,      iOpen(NULL,PERIOD_M30,0) );
      
           ObjectSet    ("M30_OPEN", OBJPROP_RAY,         false);
           ObjectSet    ("M30_OPEN", OBJPROP_COLOR,       Lime);
           ObjectSet    ("M30_OPEN", OBJPROP_WIDTH,       3);
       }
    
       if (M30_HIGH) // draw if true
       {
       if (ObjectFind   ("M30_HIGH") == -1) 
           ObjectCreate ("M30_HIGH", OBJ_TREND, 0, 0, 0, 0, 0);
         
           ObjectSet    ("M30_HIGH", OBJPROP_TIME1,       Time[0] +  bars_forward * 60 * Period() );
           ObjectSet    ("M30_HIGH", OBJPROP_TIME2,       Time[0] + (LevelLineLength+1) * bars_forward * 60 * Period() );
      
           ObjectSet    ("M30_HIGH", OBJPROP_PRICE1,      iHigh(NULL, PERIOD_M30, 0) );
           ObjectSet    ("M30_HIGH", OBJPROP_PRICE2,      iHigh(NULL, PERIOD_M30, 0) );
      
           ObjectSet    ("M30_HIGH", OBJPROP_RAY,         false);
           ObjectSet    ("M30_HIGH", OBJPROP_COLOR,       Lime);
           ObjectSet    ("M30_HIGH", OBJPROP_WIDTH,       3);
       }
    
       if (M30_LOW) // draw if true
       {
       if (ObjectFind   ("M30_LOW") == -1) 
           ObjectCreate ("M30_LOW",  OBJ_TREND, 0, 0, 0, 0, 0);
         
           ObjectSet    ("M30_LOW",  OBJPROP_TIME1,       Time[0] +                   bars_forward * 60 * Period() );
           ObjectSet    ("M30_LOW",  OBJPROP_TIME2,       Time[0] + (LevelLineLength+1) * bars_forward * 60 * Period() );
      
           ObjectSet    ("M30_LOW",  OBJPROP_PRICE1,      iLow(NULL, PERIOD_M30, 0) );
           ObjectSet    ("M30_LOW",  OBJPROP_PRICE2,      iLow(NULL, PERIOD_M30, 0) );
      
           ObjectSet    ("M30_LOW",  OBJPROP_RAY,         false);
           ObjectSet    ("M30_LOW",  OBJPROP_COLOR,       Lime);
           ObjectSet    ("M30_LOW",  OBJPROP_WIDTH,       3);
       }   
         
       if (M30_CLOSE) // draw if true
       {
       if (ObjectFind   ("M30_CLOSE") == -1) 
           ObjectCreate ("M30_CLOSE",  OBJ_TREND, 0, 0, 0, 0, 0);
         
           ObjectSet    ("M30_CLOSE",  OBJPROP_TIME1,       Time[0] +                   bars_forward * 60 * Period() );
           ObjectSet    ("M30_CLOSE",  OBJPROP_TIME2,       Time[0] + (LevelLineLength+1) * bars_forward * 60 * Period() );
      
           ObjectSet    ("M30_CLOSE",  OBJPROP_PRICE1,      iClose(NULL, PERIOD_M30, 1) );
           ObjectSet    ("M30_CLOSE",  OBJPROP_PRICE2,      iClose(NULL, PERIOD_M30, 1) );
      
           ObjectSet    ("M30_CLOSE",  OBJPROP_RAY,         false);
           ObjectSet    ("M30_CLOSE",  OBJPROP_COLOR,       Lime);
           ObjectSet    ("M30_CLOSE",  OBJPROP_WIDTH,       3);
       }    
         
//-----M30 LINE LABELS
//--       
       if (M30_OPEN) // draw if true
       {
       if (ObjectFind   ("M30_OPEN_label") == -1) 
           ObjectCreate ("M30_OPEN_label", OBJ_TEXT, 0, 0, 0);
      
           ObjectSet    ("M30_OPEN_label", OBJPROP_TIME1, Time[0] + (LabelAdjHorizontal+1) *bars_forward * 60 * Period() );
           ObjectSet    ("M30_OPEN_label", OBJPROP_PRICE1,(iOpen(NULL, PERIOD_M30, 0)+ LabelAdjVertical));

           ObjectSet    ("M30_OPEN_label", OBJPROP_COLOR, Lime);
           ObjectSetText("M30_OPEN_label", " M30_O", font_size, "Arial", Lime); 
       }
            
       if (M30_HIGH) // draw if true
       {
       if (ObjectFind   ("M30_HIGH_label") == -1) 
           ObjectCreate ("M30_HIGH_label", OBJ_TEXT, 0, 0, 0);
      
           ObjectSet    ("M30_HIGH_label", OBJPROP_TIME1, Time[0] + (LabelAdjHorizontal+1) *bars_forward * 60 * Period() );
           ObjectSet    ("M30_HIGH_label", OBJPROP_PRICE1,(iHigh(NULL, PERIOD_M30, 0)+LabelAdjVertical) );

           ObjectSet    ("M30_HIGH_label", OBJPROP_COLOR, Lime);
           ObjectSetText("M30_HIGH_label", " M30_H", font_size, "Arial", Lime); 
       }
    
       if (M30_LOW) // draw if true
       {
       if (ObjectFind   ("M30_LOW_label") == -1) 
           ObjectCreate ("M30_LOW_label", OBJ_TEXT, 0, 0, 0);
      
           ObjectSet    ("M30_LOW_label", OBJPROP_TIME1, Time[0] + (LabelAdjHorizontal+1) *bars_forward * 60 * Period() );
           ObjectSet    ("M30_LOW_label", OBJPROP_PRICE1,(iLow(NULL, PERIOD_M30, 0)+LabelAdjVertical) );

           ObjectSet    ("M30_LOW_label", OBJPROP_COLOR, Lime);
           ObjectSetText("M30_LOW_label", " M30_L", font_size, "Arial", Lime); 
       }  
       
       if (M30_CLOSE) // draw if true
       {
       if (ObjectFind   ("M30_CLOSE_label") == -1) 
           ObjectCreate ("M30_CLOSE_label", OBJ_TEXT, 0, 0, 0);
      
           ObjectSet    ("M30_CLOSE_label", OBJPROP_TIME1, Time[0] + (LabelAdjHorizontal+1) *bars_forward * 60 * Period() );
           ObjectSet    ("M30_CLOSE_label", OBJPROP_PRICE1,(iClose(NULL, PERIOD_M30, 1)+LabelAdjVertical) );

           ObjectSet    ("M30_CLOSE_label", OBJPROP_COLOR, Lime);
           ObjectSetText("M30_CLOSE_label", " M30_C", font_size, "Arial", Lime); 
       }  
//-------------------------------------------------------------------+
       }   //-End of M30 Loop
//-------------------------------------------------------------------+     
//-
//----
   return(0);
   }
//+------------------------------------------------------------------+